<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'object.mail_sender.title' | translate}}
          <span class="float-right">
            <button (click)="addMailSender()" [disabled]="!isAcction"
                    class="btn btn-block btn-primary">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body">
          <div class="row mb-2">
            <div class="col-10">
              <span class="float-left pr-3" style="line-height: 33px">{{'common.show' | translate}}</span>
              <select (change)="changeLimit()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px" [disabled]="!isAcction">
                <option *ngFor="let limitElement of limits" value="{{limitElement}}">{{limitElement}}</option>
              </select>
            </div>
            <div class="col-2 float-right">
              <div class="input-group " style="width: 100%">
                <input [(ngModel)]="txtSearch" type="text" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="search()" class="btn btn-dark" type="button" [disabled]="!isAcction">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>

          </div>
          <form [formGroup]="mailSenderFormGroup">
            <table class="table table-bordered table-sort-icon">
              <thead>
              <tr [disabled]="!isAcction" appSort [(orderBy)]="order.orderBy" [(orderType)]="order.orderType"
                  (orderChange)="changeOder($event)">
                <th appSortBy="email" class="text-center">
                  {{'object.mail_sender.email' | translate}}
                  <fa-icon></fa-icon>
                </th>

                <th
                    class="text-center">
                  {{'object.mail_sender.password' | translate}}
                </th>
                <th
                    class="text-center">
                  {{'object.mail_sender.mail_server' | translate}}
                </th>
                <th
                  class="text-center">
                  {{'common.action' | translate}}
                </th>
              </tr>
              </thead>
              <ng-container *ngIf="mailSenders && mailSenders.length >= 0">
                <tbody formArrayName="data" *ngFor="let mailSender of getFormData.controls; let i=index">

                <tr [formGroupName]="i" *ngIf=" mailSender">
                  <!--email -->
                  <td>
                  <span *ngIf="!mailSender.get('is_update').value">
                    {{mailSender.get('email').value}}
                  </span>
                    <div *ngIf="mailSender.get('is_update').value">
                      <input type="text" class="form-control" formControlName="email"
                             placeholder="{{'object.mail_sender.email' | translate}}">
                      <div>
                        <!--<span class="text-danger d-block"-->
                        <!--*ngIf="mailSender.get('email').errors && mailSender.get('email').touched && mailSender.get('email').errors.required">{{'error.validate.email.required' | translate}}</span>-->
                        <!--<span class="text-danger d-block"-->
                        <!--*ngIf="mailSender.get('email').errors && mailSender.get('email').touched && mailSender.get('email').errors.email">{{'error.validate.email.pattern' | translate}}</span>-->
                        <!--<span class="text-danger d-block"-->
                        <!--*ngIf="mailSender.get('email').errors && mailSender.get('email').touched && mailSender.get('email').errors.maxlength">{{'error.validate.email.maxlength' | translate}}</span>-->
                        <!--<span class="text-danger d-block"-->
                        <!--*ngIf="mailSender.get('email').errors && mailSender.get('email').touched && mailSender.get('email').errors.minlength">{{'error.validate.email.minlength' | translate}}</span>-->
                        <span class="text-danger d-block"
                              *ngIf="mailSender.get('email').errors && mailSender.get('email').touched && mailSender.get('email').invalid">{{'error.validate.email.valid' | translate}}</span>
                      </div>
                    </div>
                  </td>

                  <!--password -->
                  <td>
                    <div class="input-group" *ngIf="!mailSender.get('is_update').value">
                      <input [type]="mailSender.get('is_show_password').value? 'text' : 'password'"
                             class="form-control" readonly="readonly"
                             [value]="mailSender.get('password').value"
                             placeholder="{{'object.mail_sender.password' | translate}}"
                      >
                      <div class="input-group-append">
                    <span
                      (click)="mailSender.get('is_show_password').setValue(!mailSender.get('is_show_password').value)"
                      class="input-group-text"
                      style="cursor: pointer;">
                      <i
                        [class]="mailSender.get('is_show_password').value? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i></span>
                      </div>
                    </div>
                    <div *ngIf="mailSender.get('is_update').value">
                      <div class="input-group">
                        <input formControlName="password"
                               [type]="mailSender.get('is_show_password').value? 'text' : 'password'"
                               class="form-control"
                        >
                        <div class="input-group-append">
                    <span
                      (click)="mailSender.get('is_show_password').setValue(!mailSender.get('is_show_password').value)"
                      class="input-group-text"
                      style="cursor: pointer;">
                      <i
                        [class]="mailSender.get('is_show_password').value? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i></span>
                        </div>
                      </div>
                      <div>
                      <span class="text-danger d-block"
                            *ngIf="mailSender.get('password').errors && mailSender.get('password').touched && mailSender.get('password').errors.maxlength">{{'error.validate.password.maxlength' | translate}}</span>
                        <span class="text-danger d-block"
                              *ngIf="mailSender.get('password').errors && mailSender.get('password').touched && mailSender.get('password').errors.required">{{'error.validate.password.required' | translate}}</span>
                        <span class="text-danger d-block"
                              *ngIf="mailSender.get('password').errors && mailSender.get('password').touched && mailSender.get('password').errors.pattern">{{'error.validate.password.pattern' | translate}}</span>
                        <span class="text-danger d-block"
                              *ngIf="mailSender.get('password').errors && mailSender.get('password').touched && mailSender.get('password').errors.minlength">{{'error.validate.password.minlength' | translate}}</span>
                      </div>

                    </div>

                  </td>
                  <!-- mail server -->
                  <td>
                  <span
                    *ngIf="!mailSender.get('is_update').value && mapMailServer[mailSender.get('mail_server_id').value]">
                    {{mapMailServer[mailSender.get('mail_server_id').value].mail_server_name}}
                  </span>

                    <div *ngIf="mailSender.get('is_update').value">
                      <div class="input-group">
                        <select class="form-control" formControlName="mail_server_id">
                          <!--<option value="">{{'object.mail_sender.select_mail_server' | translate}}</option>-->
                          <option *ngFor="let mailServer of mailServers" value="{{mailServer.id}}">
                            {{mailServer.mail_server_name}}
                          </option>
                        </select>
                      </div>
                      <span class="text-danger"
                            *ngIf="mailSender.get('mail_server_id').touched && mailSender.get('mail_server_id').invalid">{{'error.validate.input_required' | translate}}</span>
                    </div>

                  </td>

                  <!--acction-->
                  <td class="text-center">
                    <div class="btn-group">
                      <button *ngIf="!mailSender.get('is_update').value" (click)="onEdit(i)" [disabled]="!isAcction"
                              type="submit"
                              class="btn btn-success btn-sm">
                        <i class="icon-pencil"></i>
                        <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                      </button>
                      <button *ngIf="mailSender.get('is_update').value" (click)="save(saveModal, i)" type="submit"
                              [disabled]="mailSender.invalid"
                              class="btn btn-primary btn-sm">
                        <i class="fa fa-save"></i>
                        <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                      </button>
                      <button *ngIf="!mailSender.get('is_update').value" type="submit" (click)="remove(deleteModal, i)"
                              class="btn btn-danger btn-sm" [disabled]="!isAcction">
                        <i class="icon-trash"></i>
                        <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                      </button>
                      <button *ngIf="mailSender.get('is_update').value" type="submit" (click)="onCancelEdit(i)"
                              class="btn btn-danger btn-sm">
                        <i class="icon-action-undo"></i>
                        <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                      </button>
                    </div>
                  </td>
                </tr>
                </tbody>
              </ng-container>

            </table>
          </form>
          <div class="row">
            <div class="col-12">

              <span *ngIf="mailSenders.length !== 0 " style="line-height: 33px" class="float-left">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + mailSenders.length),
              total: paging.total
            } }}</span>
              <ngb-pagination  *ngIf="mailSenders.length !== 0 " class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)">
              </ngb-pagination>
              <div *ngIf="!mailSenders || mailSenders.length === 0" class="text-center">
                <span>{{'common.no_record' | translate}}</span>
              </div>
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>
</div>


<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'object.mail_sender.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'object.mail_sender.delete_popup.message' | translate: {email : selectedMailSender.email} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('delete')">{{'common.delete' | translate}}
    </button>
    <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' | translate}}
    </button>
  </div>
</ng-template>

<ng-template #saveModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-save-title">{{'object.mail_sender.save_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'object.mail_sender.save_popup.message' | translate: {email : selectedMailSender.email} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('save')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' | translate}}
    </button>
  </div>
</ng-template>

